<%
	' extend_chars.asp - script which displays a form to use in testing extended character
	' set input and encoding for imode, wml, or xhtml content. Script is able to test both
	' GET and POST methods
	'
	' usage: extend_chars.asp?content=[WML|IMODE|XHTML]&method=[get|post]
	' notes: case is significant in atribute values; iMode HTML and WML use <input> field;
	'   XHTML uses <textarea> element instead
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	
	testSize = 25			' size of the test string, in characters
	arraySize = 124			' size of array
	Dim charSet()			' array of characters to test 
	Redim charSet(arraySize)
	
	'Init array with character entities:
	
	' Greek 
	charSet(0) = "&Alpha;" ' greek capital letter alpha
	charSet(1) = "&Beta;" ' greek capital letter beta
	charSet(2) = "&Gamma;" ' greek capital letter gamma
	charSet(3) = "&Delta;" ' greek capital letter delta
	charSet(4) = "&Epsilon;" ' greek capital letter epsilon
	charSet(5) = "&Zeta;" ' greek capital letter zeta
	charSet(6) = "&Eta;" ' greek capital letter eta
	charSet(7) = "&Theta;" ' greek capital letter theta
	charSet(8) = "&Iota;" ' greek capital letter iota
	charSet(9) = "&Kappa;" ' greek capital letter kappa
	charSet(10) = "&Lambda;" ' greek capital letter lambda
	charSet(11) = "&Mu;" ' greek capital letter mu
	charSet(12) = "&Nu;" ' greek capital letter nu 
	charSet(13) = "&Xi;" ' greek capital letter xi 
	charSet(14) = "&Omicron;" ' greek capital letter omicron
	charSet(15) = "&Pi;" ' greek capital letter pi
	charSet(16) = "&Rho;" ' greek capital letter rho
	charSet(17) = "&Sigma;" ' greek capital letter sigma
	charSet(18) = "&Tau;" ' greek capital letter tau
	charSet(19) = "&Upsilon;" ' greek capital letter upsilon
	charSet(20) = "&Phi;" ' greek capital letter phi
	charSet(21) = "&Chi;" ' greek capital letter chi
	charSet(22) = "&Psi;" ' greek capital letter psi
	charSet(23) = "&Omega;" ' greek capital letter omega
	charSet(24) = "&alpha;" ' greek small letter alpha
	charSet(25) = "&beta;" ' greek small letter beta
	charSet(26) = "&gamma;" ' greek small letter gamma
	charSet(27) = "&delta;" ' greek small letter delta
	charSet(28) = "&epsilon;" ' greek small letter epsilon
	charSet(29) = "&zeta;" ' greek small letter zeta
	charSet(30) = "&eta;" ' greek small letter eta
	charSet(31) = "&theta;" ' greek small letter theta
	charSet(32) = "&iota;" ' greek small letter iota
	charSet(33) = "&kappa;" ' greek small letter kappa
	charSet(34) = "&lambda;" ' greek small letter lambda
	charSet(35) = "&mu;" ' greek small letter mu
	charSet(36) = "&nu;" ' greek small letter nu
	charSet(37) = "&xi;" ' greek small letter xi
	charSet(38) = "&omicron;" ' greek small letter omicron
	charSet(39) = "&pi;" ' greek small letter pi
	charSet(40) = "&rho;" ' greek small letter rho
	charSet(41) = "&sigmaf;" ' greek small letter final sigma
	charSet(42) = "&sigma;" ' greek small letter sigma
	charSet(43) = "&tau;" ' greek small letter tau
	charSet(44) = "&upsilon;" ' greek small letter upsilon
	charSet(45) = "&phi;" ' greek small letter phi
	charSet(46) = "&chi;" ' greek small letter chi
	charSet(47) = "&psi;" ' greek small letter psi
	charSet(48) = "&omega;" ' greek small letter omega
	charSet(49) = "&thetasym;" ' greek small letter theta symbol
	charSet(50) = "&upsih;" ' greek upsilon with hook symbol 
	charSet(51) = "&piv;" ' greek pi symbol

	' General Punctuation 
	charSet(52) = "&bull;" ' bullet = black small circle
	charSet(53) = "&hellip;" ' horizontal ellipsis  
	charSet(54) = "&prime;" ' prime = minutes = feet
	charSet(55) = "&Prime;" ' double prime = seconds = inches
	charSet(56) = "&oline;" ' overline = spacing overscore
	charSet(57) = "&frasl;" ' fraction slash

	' Letterlike Symbols 
	charSet(58) = "&weierp;" ' script capital P 
	charSet(59) = "&image;" ' blackletter capital I 
	charSet(60) = "&real;" ' blackletter capital R 
	charSet(61) = "&trade;" ' trade mark sign
	charSet(62) = "&alefsym;" ' alef symbol

	' Arrows 
	charSet(63) = "&larr;" ' leftwards arrow
	charSet(64) = "&uarr;" ' upwards arrow
	charSet(65) = "&rarr;" ' rightwards arrow
	charSet(66) = "&darr;" ' downwards arrow
	charSet(67) = "&harr;" ' left right arrow
	charSet(68) = "&crarr;" ' downwards arrow with corner leftwards                                
	charSet(69) = "&lArr;" ' leftwards double arrow
	charSet(70) = "&uArr;" ' upwards double arrow 
	charSet(71) = "&rArr;" ' rightwards double arrow 
	charSet(72) = "&dArr;" ' downwards double arrow
	charSet(73) = "&hArr;" ' left right double arrow

	' Mathematical Operators 
	charSet(74) = "&forall;" ' for all
	charSet(75) = "&part;" ' partial differential
	charSet(76) = "&exist;" ' there exists
	charSet(77) = "&empty;" ' empty set = null set 
	charSet(78) = "&nabla;" ' nabla = backward diff 
	charSet(79) = "&isin;" ' element of
	charSet(80) = "&notin;" ' not an element of
	charSet(81) = "&ni;" ' contains as member
	charSet(82) = "&prod;" ' n-ary product 
	charSet(83) = "&sum;" ' n-ary sumation
	charSet(84) = "&minus;" ' minus sign
	charSet(85) = "&lowast;" ' asterisk operator
	charSet(86) = "&radic;" ' square root = radical sign
	charSet(87) = "&prop;" ' proportional to
	charSet(88) = "&infin;" ' infinity
	charSet(89) = "&ang;" ' angle
	charSet(90) = "&and;" ' logical and 
	charSet(91) = "&or;" ' logical or 
	charSet(92) = "&cap;" ' intersection 
	charSet(93) = "&cup;" ' union 
	charSet(94) = "&int;" ' integral
	charSet(95) = "&there4;" ' therefore
	charSet(96) = "&sim;" ' tilde operator 
	charSet(97) = "&cong;" ' approximately equal to
	charSet(98) = "&asymp;" ' almost equal to
	charSet(99) = "&ne;" ' not equal to
	charSet(101) = "&equiv;" ' identical to
	charSet(102) = "&le;" ' less-than or equal to
	charSet(103) = "&ge;" ' greater-than or equal to
	charSet(104) = "&sub;" ' subset of
	charSet(105) = "&sup;" ' superset of
	charSet(106) = "&nsub;" ' not a subset of
	charSet(107) = "&sube;" ' subset of or equal to
	charSet(108) = "&supe;" ' superset of or equal to
	charSet(109) = "&oplus;" ' circled plus = direct sum
	charSet(110) = "&otimes;" ' circled times = vector product
	charSet(111) = "&perp;" ' up tack = orthogonal to = perpendicular               
	charSet(112) = "&sdot;" ' dot operator

	' Miscellaneous Technical 
	charSet(113) = "&lceil;" ' left ceiling = apl upstile
	charSet(114) = "&rceil;" ' right ceiling
	charSet(115) = "&lfloor;" ' left floor = apl downstile
	charSet(116) = "&rfloor;" ' right floor
	charSet(117) = "&lang;" ' left-pointing angle bracket
	charSet(118) = "&rang;" ' right-pointing angle bracket

	' Geometric Shapes 
	charSet(119) = "&loz;" ' lozenge

	' Miscellaneous Symbols 
	charSet(120) = "&spades;" ' black spade suit
	charSet(121) = "&clubs;" ' black club suit = shamrock 
	charSet(122) = "&hearts;" ' black heart suit = valentine 
	charSet(123) = "&diams;" ' black diamond suit

	' Latin Extended-B 
	charSet(124) = "&fnof;" ' latin small f with hook = function
	                                    
	'''''''''''''''''''''''MAIN PROGRAM''''''''''''''''''''''''''''''''
		
    content=Request.QueryString("content")
    method=Request.QueryString("method") 
    
    ' default attributes
    if (content = "") then
		content = "IMODE"
	end if

	
	' depending on type of content desired, output the appropriate header and starting content
    if (content = "IMODE") then
    	Response.Write "<html>" & vbCrLf & "<head><title>Extended Chars iMODE" & "</title></head>" & vbCrLf & "<body>" & vbCrLf
		Response.Write "<h4>Extended Chars iMODE" & "</h4>" & vbCrLf 
	elseif (content = "XHTML") then
		Response.Write "<?xml version='1.0'?>" & vbCrLf & "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML Basic 1.0//EN' " & vbCrLf & "'http://www.w3.org/TR/xhtml-basic/xhtml-basic10.dtd'>" & vbCrLf
		Response.Write "<html xmlns='http://www.w3.org/1999/xhtml'>" & vbCrLf
		Response.Write "<head><title>Extended Chars XHTML" & "</title></head>" & vbCrLf & "<body>" & vbCrLf
		Response.Write "<h4>Extended Chars XHTML" & "</h4>" & vbCrLf
	else
		Response.ContentType="text/vnd.wap.wml"
		Response.Write "<?xml version='1.0'?>" & vbCrLf & "<!DOCTYPE wml PUBLIC '-//WAPFORUM//DTD WML 1.2//EN' 'http://www.wapforum.org/DTD/wml_1.2.xml'>" & vbCrLf
		Response.Write "<wml>" & vbCrLf & "<card newcontext='true' title='Extended Chars WML" & "'>" & vbCrLf
		Response.Write "<p><big>Extended Chars WML" & "</big></p>" & vbCrLf		
	end if

	' pick a random subset of characters within the predefined extended set
	Response.Write "<p>Verify that these character entities do not crash the browser.</p>" & vbCrLf

	Randomize
	Response.Write "<p>"  & vbCrLf
	For varCounter = 1 to testSize
		intValue = Int((arraySize + 1) * Rnd)
		Response.Write  charSet(intValue) & " "
	Next  
	Response.Write vbCrLf
	Response.Write "</p>"  & vbCrLf

	' output appropriate form content and footer based on content type specified
		
	if (content = "IMODE") then
		Response.Write "<p><a href='extended_named.html'>Back</a></p>" & vbCrLf
		Response.Write "</body>" & vbCrLf & "</html>"
	elseif (content = "XHTML")then
		Response.Write "<p><a href='extended_named.xhtml'>Back</a></p>" & vbCrLf
		Response.Write "</body>" & vbCrLf & "</html>"
	else  
		Response.Write "<p><a href='extended_named.wml'>Back</a></p>" & vbCrLf
		Response.Write "</card>" & vbCrLf & "</wml>"
	end if
%>
